local VEHICLE, TOOL, OBJECT, PLACEABLE = "VEHICLE","TOOL", "OBJECT", "PLACEABLE"

function TidyShop:initializeCategories()

    -- EXAMPLES
    -- -- HOWTO: self:addCategory(TYPE, "NEW_CATEGORY_NAME", "New Category Title", "category_image_path", "EXISTING_SIBLING_CATEGORY", categoryIndexOffset)
    -- self:addCategory(VEHICLE, "TRACTORSXL", "XL Tractors", "$data/vehicles/fendt/mt1100/store_mt1100.dds", "TRACTORSL", 1)
    -- self:addCategory(VEHICLE, "TRACTORSXS", "Compact Tractors", "images/cat_tractorsxs.dds", "TRACTORSS", -1)

    -- ### VEHICLES ###

    -- Prepare by moving TRUCKS and CARS to the beginning of the list
    self:moveCategory("TRUCKS", nil, -10)
    self:moveCategory("CARS", nil, -20)

    -- Categories positioned based on TRACTORS
    self:addCategory(VEHICLE, "TRACTORSXS", "Compact / Sub-compact Tractors", "images/cat_tractorsxs.dds", "TRACTORSS", -1) -- Credits: Free PNG
    self:addCategory(VEHICLE, "TRACTORSXL", "XL / Tracked Tractors", "$data/vehicles/fendt/mt1100/store_mt1100.dds", "TRACTORSL", 1) -- Credits: Giants

    -- Categories positioned based on CARS
    self:addCategory(VEHICLE, "ATV", "UTV & ATV", "images/cat_atv.dds", "CARS", -1) -- Credits: Farmer_Andy
    self:addCategory(VEHICLE, "LCV", "Vans / Light Commercial Vehicles", "images/cat_lcv.dds", "CARS", 1) -- Credits: MB ProductWeb Image

    -- Categories positioned based on TRUCKS
    -- self:addCategory(VEHICLE, "SMALLTRUCKS", "Small Trucks", "images/cat_smalltrucks.dds", "TRUCKS", -1); --TODO: TBD
    
    self:addCategory(VEHICLE, "SPECIALTRUCKS", "Fixed-body Trucks", "images/cat_fixedbodytrucks.dds", "TRUCKS", 1); -- Credits: Farmer_Andy
    self:addCategory(VEHICLE, "FIXEDBODYTRUCKS", "Fixed-body Trucks", "images/cat_fixedbodytrucks.dds", "TRUCKS", 1); -- Credits: Farmer_Andy

    self:addCategory(VEHICLE, "HKLVEHICLES", "Hooklift Vehicles", "images/cat_hklvehicles.dds", "TRUCKS", 2); -- Credits: NLD Community + Giants
    self:addCategory(VEHICLE, "HKLTRUCKS", "Hooklift Trucks", "images/cat_hkltrucks.dds", "TRUCKS", 2); -- Credits: NLD Community
    self:addCategory(VEHICLE, "ARVEHICLES", "SwapBody/AR Vehicles", "images/cat_arvehicles.dds", "TRUCKS", 2); -- Credits: BlackSheep Modding
    self:addCategory(VEHICLE, "ARTRUCKS", "SwapBody/AR Trucks", "images/cat_artrucks.dds", "TRUCKS", 2); -- Credits: BlackSheep Modding

    -- Categories positioned based on WHEELLOADERVEHICLES
    -- self:addCategory(VEHICLE, "BACKHOELOADERS", "Backhoe Loaders", "images/cat_backhoeloaders.dds", "WHEELLOADERVEHICLES", 1); --TODO: TBD

    -- Categories positioned based on SKIDSTEERVEHICLES
    -- self:addCategory(VEHICLE, "BULLDOZERS", "Bulldozers", "images/cat_dozers.dds", "SKIDSTEERVEHICLES", 1); --TODO: TBD
    self:addCategory(VEHICLE, "EXCAVATORS", "Excavators", "images/cat_excavators.dds", "SKIDSTEERVEHICLES", 2); -- Credits: BlackSheep
    self:addCategory(VEHICLE, "CONSTRUCTION", "Construction / Mining", "images/cat_construction.dds", "SKIDSTEERVEHICLES", 3); -- Credits: WZL + Giants

    -- Categories positioned based on MISCVEHICLES
    self:addCategory(VEHICLE, "EMERGENCY", "Emergency / Rescue", "images/cat_default.dds", "MISCVEHICLES", 1); --TODO: TBD
    self:addCategory(VEHICLE, "COMMUNAL", "Municipal / Public Works", "images/cat_default.dds", "MISCVEHICLES", 1); --TODO: TBD


    -- ### TOOLS & IMPLEMENTS ###

    self:moveCategory("TRAILERS", nil, -20)

    -- Specialized
    
    self:addCategory(TOOL, "HKLTOOLS", "Hooklift Containers", "images/cat_hkltools.dds", "TRAILERS", -5); -- Credits: Giants
    self:addCategory(TOOL, "HKLTRAILERS", "Hooklift Trailers", "images/cat_hkltrailers.dds", "TRAILERS", -5); -- Credits: Giants
    self:addCategory(TOOL, "ARFRAMES", "SwapBody Superstructures", "images/cat_arframes.dds", "TRAILERS", -6); -- Credits: BlackSheep Modding
    self:addCategory(TOOL, "ARTRAILERS", "SwapBody Trailers", "images/cat_artrailers.dds", "TRAILERS", -6); -- Credits: VBM Modding
    self:addCategory(TOOL, "SNOWTOOLS", "Snow/Winter", "images/cat_snowtools.dds", "MISC", -3); -- Credits: Giants
    self:addCategory(TOOL, "CRANETOOLS", "Cranes & Transport", "images/cat_cranestools.dds", "MISC", -2); -- Credits: BlackSheep + Giants
    self:addCategory(TOOL, "HANDTOOLS", "Hand Tools", "images/cat_handtools.dds", "MISC", -1); -- Credits: Giants

    self:addCategory(TOOL, "LIQUIDSTRANSPORT", "Liquids Transport", "images/cat_liquidstransport.dds", "ARTRAILERS", -1); -- Preferred name   -- Credits: Farmer_Andy + Giants
    self:addCategory(TOOL, "LIQUIDTRANSPORT", "Liquids Transport", "images/cat_liquidstransport.dds", "LIQUIDSTRANSPORT", 0); -- CategoryAdder compat  -- Credits: Farmer_Andy + Giants
    self:addCategory(TOOL, "LIQUIDSTRANSPORTALL", "Liquids Transport", "images/cat_liquidstransportall.dds", "LIQUIDSTRANSPORT", 0); -- Credits: Farmer_Andy + Giants
    self:addCategory(TOOL, "TANKSHOSES", "Tanks & Hoses", "images/cat_tankshoses.dds", "LIQUIDSTRANSPORT", 0);  -- Credits: Farmer_Andy

    -- Trailers
	self:addCategory(TOOL, "ATVTRAILERS", "UTV / ATV Trailers", "images/cat_atvtrailers.dds", "TRAILERS", -2); -- Credits: Farmer_Andy
    self:addCategory(TOOL, "LIGHTTRAILERS", "Light Trailers", "images/cat_lighttrailers.dds", "TRAILERS", -1); -- Credits: Euro Agri Modding
    self:addCategory(TOOL, "FLATBEDTRAILERS", "Flatbed Trailers", "images/cat_default.dds", "TRAILERS", 1); --TODO: TBD
    self:addCategory(TOOL, "LOWLOADERTRAILER", "Equipment Trailers", "images/cat_default.dds", "TRAILERS", 2); --TODO: TBD
    self:addCategory(TOOL, "LIQUIDSTRAILERS", "Liquids Trailers", "$data/vehicles/lizard/mks8/store_mks8.dds", "TRAILERS", 3); -- Credits: Giants

    -- Semitrailers
    self:addCategory(TOOL, "SEMITRAILERS", "Semitrailers", "$data/vehicles/lodeKing/distinction/store_distinction.dds", "TRAILERS", 10); --TODO: fix hack!!
	self:addCategory(TOOL, "BULKSEMITRAILERS", "Bulk Semitrailers", "$data/vehicles/lodeKing/distinction/store_distinction.dds", "SEMITRAILERS", 1); -- Credits: Giants
	self:addCategory(TOOL, "FLATBEDSEMITRAILERS", "Flatbed Semitrailers", "images/cat_default", "SEMITRAILERS", 2); --TODO: TBD
    self:addCategory(TOOL, "LIQUIDSEMITRAILERS", "Liquids Semitrailers", "$data/vehicles/lizard/mks32/store_mks32.dds", "SEMITRAILERS", 3); -- Credits: Giants
    self:addCategory(TOOL, "LIQUIDSSEMITRAILERS", "Liquids Semitrailers", "$data/vehicles/lizard/mks32/store_mks32.dds", "SEMITRAILERS", 3); -- Credits: Giants
    self:moveCategory("LOWLOADERS", "SEMITRAILERS", 4)
    self:addCategory(TOOL, "LOWLOADERSEMITRAILERS", "Low Loaders", "$data/vehicles/goldhofer/goldhoferStzVp3/store_goldhoferStzVp3.dds", "SEMITRAILERS", 4); -- Credits: Giants

    -- Equipment
    -- self:addCategory(TOOL, "BULLDOZERTOOLS", "Bulldozers", "images/cat_dozertools.dds", "SKIDSTEERS", 1); --TODO: TBD
    self:addCategory(TOOL, "EXCAVATORTOOLS", "Excavators & Backhoes", "images/cat_excavatortools.dds", "SKIDSTEERS", 2);  -- Credits: BlackSheep
    self:addCategory(TOOL, "BACKHOETOOLS", "Excavators & Backhoes", "images/cat_excavatortools.dds", "SKIDSTEERS", 2); -- Credits: BlackSheep
    self:addCategory(TOOL, "CONSTRUCTIONTOOLS", "Construction / Mining", "images/cat_constructiontools.dds", "SKIDSTEERS", 3);  -- Credits: WZL + Giants


    -- ### PLACEABLES ###

    self:moveCategory("GLOBALCOMPANYPLACEABLE", "ANIMALPENS", -20)

    self:addCategory(PLACEABLE, "FACTORIES", "Factories / Production", "images/cat_factories.dds", "GLOBALCOMPANYPLACEABLE", 1);
    self:addCategory(PLACEABLE, "PLACEABLE_FACTORIES", "Factories / Production", "images/cat_factories.dds", "GLOBALCOMPANYPLACEABLE", 1);
    self:addCategory(PLACEABLE, "GC_FACTORIES", "Production / Factories", "images/cat_factories.dds", "FACTORIES", 1);
    -- self:addCategory(PLACEABLE, "GLOBALCOMPANYFACTORIES", "Production / Factories", "images/cat_globalcompanyproduction.dds", "FACTORIES", 1);
    -- self:addCategory(PLACEABLE, "GLOBALCOMPANY_FACTORIES", "Production / Factories", "images/cat_globalcompanyproduction.dds", "FACTORIES", 1);
    self:addCategory(PLACEABLE, "GLOBALCOMPANYPLACEABLE", "Global Company Misc", "../FS19_GlobalCompany/store_globalCompanyPlaceable.dds", "GLOBALCOMPANYPLACEABLE", 0); -- Credits: n/a (GC icon is just linked)
    self:addCategory(PLACEABLE, "GLOBALCOMPANY_MISC", "Global Company Misc", "../FS19_GlobalCompany/store_globalCompanyPlaceable.dds", "GLOBALCOMPANYPLACEABLE", 0); -- Credits: n/a (GC icon is just linked)
    self:addCategory(PLACEABLE, "GC_MISC", "Global Company Misc", "../FS19_GlobalCompany/store_globalCompanyPlaceable.dds", "GLOBALCOMPANYPLACEABLE", 0);
    self:addCategory(PLACEABLE, "REFILLSTATIONS", "Refill stations (buy)", "$data/placeables/waterTank/store_waterTank.dds", "FACTORIES", 3); -- Credits: Giants
    self:addCategory(PLACEABLE, "PLACEABLE_REFILLSTATIONS", "Refill stations (buy)", "$data/placeables/waterTank/store_waterTank.dds", "FACTORIES", 3); -- Credits: Giants
    self:addCategory(PLACEABLE, "SELLSTATIONS", "Trade stations (sell)", "images/cat_sellpoints.dds", "FACTORIES", 4);
    self:addCategory(PLACEABLE, "PLACEABLE_SELLSTATIONS", "Trade stations (sell)", "images/cat_sellpoints.dds", "FACTORIES", 4);

    -- Energy and passive income
    self:addCategory(PLACEABLE, "RENEWABLEENERGY", "Energy (income)", "images/cat_renewableenergy.dds", "FACTORIES", 5);
    self:addCategory(PLACEABLE, "PLACEABLE_RENEWABLEENERGY", "Energy (income)", "images/cat_renewableenergy.dds", "FACTORIES", 5);
    self:addCategory(PLACEABLE, "BIOMASSENERGY", "Biomass Energy (income)", "images/cat_biomassenergy.dds", "RENEWABLEENERGY", 0);
    self:addCategory(PLACEABLE, "PLACEABLE_BIOMASSENERGY", "Biomass Energy (income)", "images/cat_biomassenergy.dds", "RENEWABLEENERGY", 0);
    -- self:addCategory(PLACEABLE, "BIOMASSENERGY", "Biomass Energy (income)", "$data/placeables/woodCrusher/jenz/store_jenzHE700.dds", "RENEWABLEENERGY", 0);
    -- self:addCategory(PLACEABLE, "PLACEABLE_BIOMASSENERGY", "Biomass Energy (income)", "$data/placeables/woodCrusher/jenz/store_jenzHE700.dds", "RENEWABLEENERGY", 0);
    self:addCategory(PLACEABLE, "SOLARENERGY", "Solar Energy (income)", "images/cat_solarenergy.dds", "RENEWABLEENERGY", 1);
    self:addCategory(PLACEABLE, "PLACEABLE_SOLARENERGY", "Solar Energy (income)", "images/cat_solarenergy.dds", "RENEWABLEENERGY", 1);
    self:addCategory(PLACEABLE, "WINDENERGY", "Wind Energy (income)", "images/cat_windenergy.dds", "RENEWABLEENERGY", 1); -- Credtis: GIANTS
    self:addCategory(PLACEABLE, "PLACEABLE_WINDENERGY", "Wind Energy (income)", "images/cat_windenergy.dds", "RENEWABLEENERGY", 1); -- Credtis: GIANTS
    self:addCategory(PLACEABLE, "GREENHOUSES", "Greenhouses & Beehives (income)", "images/cat_greenhouses.dds", "RENEWABLEENERGY", 1); -- Credtis: GIANTS
    self:addCategory(PLACEABLE, "PLACEABLE_GREENHOUSES", "Greenhouses & Beehives (income)", "images/cat_greenhouses.dds", "RENEWABLEENERGY", 1); -- Credtis: GIANTS

    -- Storage
    self:addCategory(PLACEABLE, "SILOS", "Silos & Crop Storage", "$data/placeables/farmSilos/store_farmSiloSmall.dds", "SILOS", 0); -- Credits: Giants
    self:addCategory(PLACEABLE, "LIQUIDSSTORAGE", "Liquids Storage", "images/cat_liquidstorage.dds", "SILOS", 1); -- Credits: WZL + Giants
    self:addCategory(PLACEABLE, "PLACEABLE_LIQUIDSSTORAGE", "Liquids Storage", "images/cat_liquidstorage.dds", "SILOS", 1); -- Credits: WZL + Giants
    self:addCategory(PLACEABLE, "BALESTORAGE", "Bale Storage", "images/cat_balestorage.dds", "SILOS", 2); -- Credits: WZL + Giants
    self:addCategory(PLACEABLE, "PLACEABLE_BALESTORAGE", "Bale Storage", "images/cat_balestorage.dds", "SILOS", 2); -- Credits: WZL + Giants
    self:addCategory(PLACEABLE, "CROPSTORAGE", "Produce & Crop Storage", "images/cat_default.dds", "SILOS", 2); -- Credits: Giants
    self:addCategory(PLACEABLE, "PLACEABLE_CROPSTORAGE", "Produce & Crop Storage", "images/cat_default.dds", "SILOS", 2); -- Credits: Giants
    self:addCategory(PLACEABLE, "STORAGE", "General Storage", "images/cat_default.dds", "SILOS", 3); -- Credits: Giants
    self:addCategory(PLACEABLE, "PLACEABLE_STORAGE", "General Storage", "images/cat_default.dds", "SILOS", 3); -- Credits: Giants
    self:addCategory(PLACEABLE, "PALLETSTORAGE", "Shelves & Pallet Storage", "images/cat_palletstorage.dds", "SILOS", 3); -- Credits: WZL + Giants
    self:addCategory(PLACEABLE, "PLACEABLE_PALLETSTORAGE", "Shelves & Pallet Storage", "images/cat_palletstorage.dds", "SILOS", 3); -- Credits: WZL + Giants

    -- Decorative objects
    self:addCategory(PLACEABLE, "STREETLIGHTSANDSIGNS", "Streetlights & Signs", "images/cat_signslights.dds", "PLACEABLEMISC", 1); -- Credits: WZL + Giants
	self:addCategory(PLACEABLE, "COMMUNALBUILDINGS", "Public & Communal Buildings", "images/cat_publicbuildings.dds", "PLACEABLEMISC", 1); -- Credits: WZL + Giants
    self:addCategory(PLACEABLE, "PLACEABLETRAFFIC", "Vehicles & Traffic", "images/cat_traffic.dds", "PLACEABLEMISC", 2); -- Credits: WZL + Giants
	-- self:addCategory(PLACEABLE, "DECORATIONBUILDINGS", "Decorative Buildings", "images/cat_default.dds", "DECORATION", -1);


    -- ### OBJECTS ###

    --TODO: bags (loose) + hand items (saplings?)

    self:addCategory(OBJECT, "PALLETS", "Pallets", "$data/objects/pallets/pioneer/store_pioneerPallet.dds", "PALLETS", 1); -- Credits: Giants
    self:addCategory(OBJECT, "IBCPALLETS", "IBC Tanks", "$data/objects/pallets/liquidTank/store_fertilizerTank.dds", "PALLETS", 1); -- Credits: Giants
    self:addCategory(OBJECT, "DECORATIVEPALLETS", "Decorative Pallets", "images/cat_decorativepallets.dds", "BALES", 1);

end